﻿/*
	The MIT License
	
	Copyright (c) 2008-2009 Mark Walters
	
	Permission is hereby granted, free of charge, to any person obtaining a copy
	of this software and associated documentation files (the "Software"), to deal
	in the Software without restriction, including without limitation the rights
	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	copies of the Software, and to permit persons to whom the Software is
	furnished to do so, subject to the following conditions:
	
	The above copyright notice and this permission notice shall be included in
	all copies or substantial portions of the Software.
	
	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	THE SOFTWARE.
*/

package com.yourpalmark.geoglobe
{
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IOErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	public class Geocoder extends EventDispatcher
	{
		public static const APP_ID:String = "APP_ID";
		public static const REQUEST_URL:String = "http://local.yahooapis.com/MapsService/V1/geocode";
		
		private var location:String;
		
		public function Geocoder() {}
		
		public function locate( location:String ):void
		{
			this.location = location.toLowerCase();
			var url:String = Geocoder.REQUEST_URL + "?appid=" + Geocoder.APP_ID + "&location=" + escape( location );
			var request:URLRequest = new URLRequest( url );
			var loader:URLLoader = new URLLoader();
			loader.addEventListener( Event.COMPLETE, onLoaderComplete );
			loader.addEventListener( IOErrorEvent.IO_ERROR, onLoaderIOError );
			loader.load( request );
		}
		
		
		private function onLoaderComplete( event:Event ):void
		{
			var latitude:Number;
			var longitude:Number;
			var geocoderEvent:GeocoderEvent;
			var data:XML = new XML( event.currentTarget.data );
			var yahoomaps:Namespace = new Namespace( "urn:yahoo:maps" );
			var result:XMLList = data.yahoomaps::Result;
			
			if( result.@precision )
			{
				latitude = result.yahoomaps::Latitude.toString();
				longitude = result.yahoomaps::Longitude.toString();
				geocoderEvent = new GeocoderEvent( GeocoderEvent.GEOCODER_SUCCESS, location, latitude, longitude );
				dispatchEvent( geocoderEvent );
			}
			else
			{
				dispatchEvent( new GeocoderEvent( GeocoderEvent.GEOCODER_UNAVAILABLE ) );
			}
		}
		
		private function onLoaderIOError( event:IOErrorEvent ):void
		{
			trace( "IOError" );
		}
		
	}
}